(function () {

	let ids     = "12345678-90ab-cdef-0123-456789abcdef";
	let refresh = 7;
	let options = {show:[[]], minmax:true, minmax_bar:true};

	let version = "0.9.7";
	
	setTimeout(function(){
		$("#hint").show()
	}, 4000);
	
	$(window).on("load", fetchData);
    
    $("#refresh").on("click",function(){
    	sessionStorage.clear();
    	$(".b_elem .min, .b_elem .max").text("");
    	$(".range").css("background-color","rgba(72,72,72,0.33)");
    })
	
	function fetchData(){ 
		$.post("fetch.php", {ids:ids}, function(data){ parseData(data) })
		setTimeout(fetchData, refresh*1000);
	}

	function parseData(data){
		data = JSON.parse(data);
		let complete = $('<div class="row add_row"></div>');

		$("#info-bottom .v").text(version);
		$("#info-bottom").show()

		data.forEach(function(group,index){
			if (options.show[index]?.length > 0) {
				var indexObject = _.reduce(group.d, function(result, currentObject) { result[currentObject.i] = currentObject; return result }, {});
				group.d = _.map(options.show[index], function(currentID) { return indexObject[currentID] });
			}

			let time = new Date(group.t);
			time = time.toLocaleDateString("de-DE") + " " + time.toLocaleTimeString("de-DE");
		
			let grouped = $(`<div class="col-12">
								<div class="row">
									<div class="col-12 b_group_header">
										<img src="favicon.png" width="16" height="16"/> ${group.n} <span class="time">${time}</span>
									</div>
								</div>
								<div class="row">
									<div class="col-12">
										<div class="row add_elem elem_${index}"></div>
									</div>
								</div>
							</div>`);
			
			group.d.forEach(function(el){
				if (sessionStorage.getItem(group.g+"_"+el.i+"_min")==null || parseFloat(sessionStorage.getItem(group.g+"_"+el.i+"_min"))>parseFloat(el.v)) {sessionStorage.setItem(group.g+"_"+el.i+"_min",el.v)}
				if (sessionStorage.getItem(group.g+"_"+el.i+"_max")==null || parseFloat(sessionStorage.getItem(group.g+"_"+el.i+"_max"))<parseFloat(el.v)) {sessionStorage.setItem(group.g+"_"+el.i+"_max",el.v)}
				let range = parseInt((parseFloat(el.v)-parseFloat(sessionStorage.getItem(group.g+"_"+el.i+"_min")))/(parseFloat(sessionStorage.getItem(group.g+"_"+el.i+"_max"))-parseFloat(sessionStorage.getItem(group.g+"_"+el.i+"_min")))*100) || 0;
				let n_elem = $(`<div class="col-6 col-sm-4 col-lg-3 col-xl-2">
									<div class="b_elem ${el.v==null?"warn":""}">
										<div class="min" style="${options.minmax?"":"display:none;"}">${sessionStorage.getItem(group.g+"_"+el.i+"_min")!=null?sessionStorage.getItem(group.g+"_"+el.i+"_min")+"&nbsp;"+el.u:""}</div>
										<div class="max" style="${options.minmax?"":"display:none;"}">${sessionStorage.getItem(group.g+"_"+el.i+"_max")!=null?sessionStorage.getItem(group.g+"_"+el.i+"_max")+"&nbsp;"+el.u:""}</div>
										<div class="b_data">
											<span class="b_val">${el.v==null?"---":el.v}</span>&nbsp;<span class="b_unit">${el.u}</span>
										</div>
										<div class="range" style="${options.minmax_bar?"":"display:none;"}background-color:hsla(${90-range},90%,50%,0.33);"></div>
										<div class="b_name">${el.n}</div>
									</div>
								</div>`);
				$(grouped).find(".elem_"+index).append(n_elem);
			});

			complete.append(grouped);
		});

		$(".add_row").replaceWith(complete);
	}

})()